/*
 * _version.h
 *
 *  Created on: 24. feb. 2021
 *      Author: teig
 */


#ifndef VERSION_H_
#define VERSION_H_

    /*
    ----------VER COMMITS -------------------------------------------------------------------------------
    28Mar2021 039 with TOP_03G_HAS_2_TILE_016_NODE_T0_2N_AS_CC_6CN_T1_8CN_NO_BUILD and TOP_03G_AS_PARTLY_DISTRUBUTED=1
                  and Server_node_guarded as [[distributable]] the compiler still crashes, see #158323# below, with:
                  xcc1: internal compiler error
                  Failed in /jenkins/RELEASE_14_4/sb/tools_xcc1_c_llvm/FrontEnd/Lowering/lower_combined_pars.cpp, line 183
    09Mar2021 038 TOP_20_HAS_2_TILE_004_T0_2N_BY3SUB_T1_2N_BY3SUB_RUNS_FAIR naming of nodes (1 0) and (1 1) were wrong
    08Mar2021 037 Removed code in "top_occam_like_xc.h":
                  delay_no_skew and time_admin_t
                  Client_node_3_composite_par_root__
                  Timer_test_node_short
                  Timer_test_node
    08Mar2021 036 Some timerafter code now present, discussed at
                  https://www.teigfam.net/oyvind/home/technology/165-xc-code-examples/#timerafter_to_now_and_skew
                  Will be removed on next commit
    07Mar2021 035 TOP_20_OCCAM_LIKE_IS_FAIR is now TOP_20_HAS_2_TILE_004_T0_2N_BY3SUB_T1_2N_BY3SUB_RUNS_FAIR
    07Mar2021 034 Kind of finished version
    06Mar2021 033 delay_with_offset_round_trip is new
    06Mar2021 032 Logging of timer in Client_node_3_composite_par_root OK!
    05Mar2021 031 Using "time_tmr when timerafter (time_timeout_ticks) :> void;" (new for me, seen in lib_i2c)
                  context_t defined in top_occam_like_xc.h, printing with macros there
    04Mar2021 030 Some comments, and xScope used
    03Mar2021 028 Client_node_3_composite_par_root, Client_node_3_composite_par and Server_node_3_composite_par
                  in "file top_occam_like_xc.h" with TOPOLOGY = TOP_20_OCCAM_LIKE. WORKS like a dream!
    02Mar2021 027 [[clears_notification]] takes me further..
                  See "2021 03 02 20.33 _x_test_combinable run error log.txt"
    02Mar2021 026 Some progress with TOP_03A_HAS_2_TILE_016_NODE_T0_2N_AS_CC_6CN_T1_8CN_STOPS, runs to a point
    02Mar2021 025 See "2021 03 02 08.35 _x_test_combinable run error log.txt"
    02Mar2021 024 See "2021 03 02 08.28 _x_test_combinable run error log.txt"
    01Mar2021 023 TOP_08_HAS_1_TILE_016_NODE_T0_2N_AS_CC_6CN_8CN_RUNS is new
                  HOLD_AFTER_PRINT_MS removed, since not used
    26Feb2021 022 TOP_03A_HAS_2_TILE_016_NODE_T0_2N_AS_CC_6CN_T1_8CN_RUNS and
                  TOP_03G_HAS_2_TILE_016_NODE_T0_2N_AS_CC_6CN_T1_8CN_RUNS both crash the compiler
                  Reported as XMOS ticket #158323# on 2021 02 26
                  Plus        XMOS ticket #32474#  on 2020 02 11
                  Plus        XMOS ticket #31286#  on 2018 06 26
    25Feb2021 021 top_03_asynch_xc.h being worked on. Tonight's commit
    25Feb2021 020 TOP_03G_HAS_2_TILE_016_NODE_T0_2N_AS_CC_6CN_T1_8CN_RUNS and (will not build, internal compiler error)
                  TOP_03A_HAS_2_TILE_016_NODE_T0_2N_AS_CC_6CN_T1_8CN_RUNS are new (code to be added)
                  as are files top_03_guarded_xc.h and top_03_asynch_xc.h
    24Feb2021 019 The below was not an error! It was about fairness!
    24Feb2021 018     Nicer printing. This moved into _version.h
    24Feb2021 017     Introduced a call_cnt and doing more analysis. Plus new file "debug_conf.h" for /lib_logging
                      and common view on DEBUG_PRINTF_BUFSIZE
    23Feb2021 016     Still error on TOP_03 TOP_04, equal iof_connection. analyze_all_unique_ok
                      is not always an error, see TOP_02 (so need to check (x y) too)
    23Feb2021 015     Logging of iof_pair in servers, plus analyze_all_unique_ok new
    22Feb2021 014     Learning more about index of client received in server. More printing
                      Problem with TOP_04_HAS_1_TILE_016_NODE_T0_2N_AS_CS_6CN_8CN_RUNS (at least)
                      Check  "TODO study"
    22Feb2021 013     The problem with the large values was too much printouts. Fixed with HOLD_AFTER_PRINT_MS
                      even with lib_logging!
    22Feb2021 012     Also added client_pos in server and printed that out. Got this:
                      (1 3):s(   0)     8     8 owfl [    7] [50851071] [   21] from (1 2) (1112867191 117960021) (1 0)
                      (1 1):s(   0)     6     6 owfl [    5] [71183885] [   25] from (1 0) (1881036848 4026558592) (1 2)
                      But on the second time, as below, correct
                      (1 3):s(   1)     8    90 with [   25] [   11] [   46] from (1 2) (2 2) (1 0)
                      (3 1):s(   0)    14    43 with [   13] [    1] [   15] from (3 0) (0 0) (3 2)
    22feb2021 011     On the first round with TOP_03_HAS_2_TILE_016_NODE_T0_2N_AS_CC_6CN_T1_8CN_RUNS
                      the first value from the other tile (?) seems to be wrong
                      (1 3):s(   0)     8     8 owfl [    7] [1134040328] [   21]
                      (1 1):s(   0)     6     6 owfl [    5] [2536547148] [   25]
                      But on the second time, correct
                      (1 3):s(   1)     8    90 with [   25] [   11] [   46]
                      (3 1):s(   0)    14    43 with [   13] [    1] [   15]
    21Feb2021 010 Some comments fixed
    20Feb2021 009 TOP_07_HAS_1_TILE_002_NODE_T0_2CN_RUNS is new
    18Feb2021 008 Build different versions for https://www.teigfam.net/oyvind/home/technology/217-my-xc-combined-combinable-notes/
    16Feb2021 007 Nicer printouts and overflow handled to show up
    15Feb2021 006 Handle_server now always returns old value
    15Feb2021 005 Diagram drawing and pseudo placement code finished
    14Feb2021 004 Names of TOP_NN.. as in _x_test_Toroid_1.xc
    13Feb2021 003 Cleaned up for all the versions, different numbering and all _STOPS at the end
    12Feb2021 002 Printing is now nice
    12Feb2021 001 Just testing git (2)
    12Feb2021 000 First version. XMOS https://www.xmos.ai/ticket/88288/
                  "Parameters of interface call oked when different types on client and server sides"
    */
#else
    #error Nested include VERSION_H_
#endif
